using Microsoft.EntityFrameworkCore;
using System;
using System.Runtime.Serialization;

namespace ScrumTaskboard
{
    public class TaskContext : DbContext 
    {
        public DbSet<ScrumTask> Tasks { get; set; }
        public DbSet<ScrumUserstory> Userstories { get; set; }
        public DbSet<ScrumCategory> Categories { get; set; }
        public DbSet<ScrumSprint> Sprints { get; set; }
        public DbSet<ScrumStatus> Status { get; set; }
        public DbSet<ScrumProject> Projects { get; set; }
        public DbSet<ScrumUser> Users { get; set; }

        public TaskContext() { }
        
        public TaskContext(DbContextOptions<TaskContext> options) : base(options) { }
    }

    public class ScrumTask
    {
        public int id { get; set; }
        public string title { get; set; }
        public string content { get; set; }
        public int status { get; set; }
        public int category { get; set; }
        public int assignedto { get; set; }
        public int sprint { get; set; }
        public int project { get; set; }
        public int userstory { get; set; }
        public ScrumPrio priority { get; set; }
    }

    public class ScrumUserstory
    {
        public int id { get; set; }
        public string title { get; set; }
        public string content { get; set; }
        public ScrumPrio priority { get; set; }
        public int status { get; set; }
        public int category { get; set; }
        public int createdby { get; set; }
        public int project { get; set; }
    }

    public class ScrumCategory
    {
        public int id { get; set; }
        public string title { get; set; }
        public string description { get; set; }
        public string color { get; set; }
        public int project { get; set; }
    }

    public class ScrumSprint
    {
        public int id { get; set; }
        public string title { get; set; }
        public string description { get; set; }
        public DateTime startDate { get; set; }
        public DateTime endDate { get; set; }
        public int project { get; set; }
    }

    public class ScrumStatus
    {
        public int id { get; set; }
        public string title { get; set; }
        public string description { get; set; }
    }

    public class ScrumProject
    {
        public int id { get; set; }
        public string title { get; set; }
        public bool isprivate { get; set; }
    }

    public class ScrumUser
    {
        public int id { get; set; }
        public string name { get; set; }
    }

    public enum ScrumPrio
    {
        [EnumMember(Value = "low")]
        low,
        [EnumMember(Value = "medium")]
        medium,
        [EnumMember(Value = "high")]
        high
    }
}
